﻿using System.IO;
using System.Xml;

namespace newtelligence.DasBlog.Web.Core
{
    public class SeoMetaTags
    {
        public string MetaDescription { get; set; }
        public string MetaKeywords { get; set; }
        public string SiteName { get; set; }
        
        private static string MetaConfigFile
        {
            get { return Path.Combine(SiteConfig.GetConfigPathFromCurrentContext(), "metaConfig.xml"); }
        }

        public SeoMetaTags GetMetaTags()
        {
            if (!File.Exists(MetaConfigFile))
            {
                return null;
            }

            SeoMetaTags seoMetaTags = new SeoMetaTags();

            using (XmlReader reader = XmlReader.Create(MetaConfigFile))
            {
                while (reader.Read())
                {
                    if (reader.NodeType == XmlNodeType.Element)
                    {
                        switch (reader.Name)
                        {
                            case "MetaDescription":
                                seoMetaTags.MetaDescription = reader.ReadString();
                                break;
                            case "MetaKeywords":
                                seoMetaTags.MetaKeywords = reader.ReadString();
                                break;
                        }
                    }
                }
            }
            return seoMetaTags;
        }
    }
}